/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995,
 * 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
 * 2007, 2008, 2009, 2010, 2011, 2012  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

/* set debug_level=1. */

/* run */ define test() = {
  exists A : { A=0 and 
    len(4) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) 
    
  }
}.

/* run */ define test1a() = {
  exists A : { 
    {A=0 and 
    len(1) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) }
  }
}.

/* run */ define test1b() = {
  exists A : { 
    {A=0 and 
    len(2) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) }
  }
}.

/* run */ define test1() = {
  exists A : { 
    {A=0 and  
    len(2) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) };
    {len(2) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) }
    
  }
}.

/* run */ define test2() = {
  exists A,B : { 
    {A=0 and B=2 and empty};skip;{B=prev(A)+3 and output(B) and output(prev(A)) and output(prev(B))
  and empty}
    
  }
}.

/* run */ define test3() = {
  exists A : { 
    {A=0 and 
    len(2) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) };
    {len(3) and A gets prev(A)+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) }
    
  }
}.

/* run */ define test8a() = {
    exists I,J : { len(2) and I<-I+1 and I=4 and mem(I) and J is I and always (format("I=%d J=%d\n",I,J)) }
}.

/* run */ define test9a() = {
    exists I,J : { len(4) and I=4 and I:=2 and mem(I) and J is I+1 and always (format("I=%d J=%d\n",I,J)) }
}.

/* run */ define test10a() = {
   exists X :{    
     mem(X)  and len(4) and X=0  and
     always (format("X=%d\n",X)) and
     {{skip and X:=X+1};skip;skip;skip} and
     {skip;skip;{skip and X:=X+1};skip}
   }
}.

/* run */ define test11() = {
  exists A,B : { 
    {List(A,3) and stable(struct(A)) and 
     List(B,4) and stable(struct(B))} and
    { 
     {A=[0,1,2] and B=[2] and output(A) and output(B) and empty }
     ;skip;{B=prev(A)+[3] and output(B) and output(prev(B)) and empty}
    }
  }
}.

/* run */ define test11a() = {
  exists A,B : { 
    {List(A,3) and stable(struct(A)) and 
     List(B,4) and stable(struct(B))} and
    { 
     {A=[0,1,2] and B=[2] and output(A) and output(B) and skip and
      B[0]:=3 and B[1]:=4 and next(|B|=2) and |B|=1};
     {output(B) and output(prev(B)) and empty}
    }
  }
}.

/* run */ define test12b() = {
    exists I,J,L : { list(L,3) and stable(struct(L)) and len(3) and
                     I=0 and L=[0,1,2] and L:=[4,5,6] and
                     (skip;(skip and next(output(L[1])));(L[1]=9 and skip);L=[7,6,3]) and
                     mem(L[0]) and mem(L[1]) and mem(L[2])
                     and I defaults 1 and 
                     always (output(L[I]) and output(I) and output(L)) }
}.

/* run */ define test13() = {
  exists A : { prev(A)=4 and A=0 and 
    len(2) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) 
    
  }
}.

/* run */ define test14() = {
  exists A : { A=0 and 
    len(2) and A gets A+1 and next(prev(A)=0) and
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) 
    
  }
}.
