/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
 * 2007, 2008, 2009, 2010, 2011, 2012  Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * tempura code for robot control system
 * OCS : operator control system
 * ICS : infrared control system
 * MCS : motor control system
 */

define move(X,Y) = {
  format("sending left %t  right %t \n", X, Y)
}.

define s = 0.
define f = 20.
define b = -20.
define mvl = [b,b,b,s,f,f,f,s].
define mvr = [b,s,f,f,f,s,b,b].

/* run */ define robot() = {
  exists  Loc, Roc, Lic, Ric, Opactive, Iractive, Ircounts  :
    { list(Ircounts,8) and stable(struct(Ircounts)) and

define OCS(TimeO) = {
  exists Lloc, Lroc : { 
   Lloc=s and Lroc=s and
   while true do { 
     { { empty and
         input Loc and input Roc and 
         Opactive = {if (Lloc ~= Loc) and (Lloc ~= Loc) then 1 else 0}
       };
       { if TimeO = 1 then { 
           skip
         } else {
            skip; 
            {Opactive = 0 and stable(Opactive) and len(TimeO-2)};
            skip
           }
       }
     }
     and 
     always { 
         format("Lloc = %t Lroc = %t Opactive = %t\n", Lloc, Lroc,Opactive)
     } and
     { 
       { skip and Lloc:=Loc and Lroc:=Roc} ;
       { stable(Lloc) and stable(Lroc) and len(TimeO-1) } 
     }
   }
  }
 } and

define sum(X) = {
  {if Ircounts[0]>100 then X[0] else 0} +
  {if Ircounts[1]>100 then X[1] else 0} +
  {if Ircounts[2]>100 then X[2] else 0} +
  {if Ircounts[3]>100 then X[3] else 0} +
  {if Ircounts[4]>100 then X[4] else 0} +
  {if Ircounts[5]>100 then X[5] else 0} +
  {if Ircounts[6]>100 then X[6] else 0} +
  {if Ircounts[7]>100 then X[7] else 0}
 } and

define ICS(TimeI) = {
  while true do {
    { 
      { empty and
        input Ircounts and
        Iractive = {if (exists i < 8 : Ircounts[i]>100) then 1 else 0} and
        Lic = sum(mvl) and
        Ric = sum(mvr)
      } ;
      { if TimeI=1 then {
         skip 
        } else {
           skip ;
           {Iractive = 0 and stable(Iractive) and len(TimeI-2)};
           skip
          }
      }
    } and
    always { format("Iractive = %t \n", Iractive) }
  }
 } and

define MCS(Timem) = { 
   while true do { 
   { {empty and
     if Opactive=1 then {
       format("operator move \n") and
       move(Loc,Roc) }
     else {
       if Iractive=1 then {
         format("infrared move \n") and
         move(Lic,Ric) }
       }
    };{ len(Timem) } }
  }
 } and 

 MCS(1) and ICS(2) and OCS(3)
 }    
}.
