/* This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995,
 * 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
 * 2007, 2008, 2009, 2010, 2011, 2012  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Changes made by  AC: Antonio Cau
 *                 BCM: Ben Moszkowski
 *
 * $Id: parser.h,v 2.17 2011/10/03 14:14:30 acau Exp $
 */

# define END 0
# define NIL 1
# define BOOL 2
# define INT 3
# define LAMBDA 4
# define STRING 5
# define FLOAT 6
# define LIST 7
# define STATE 8
# define STATIC 9
# define EMPTY 10
# define SKIP 11
# define AND 12
# define iAND 13
# define OR 14
# define NOT 15
# define IF 16
# define CALL 17
# define iCALL 18
# define EXISTS 19
# define iEXISTS 20
# define PROCESS 21
# define iPROCESS 22
# define PREFIX 23
# define iPREFIX 24
# define FORALL 25
# define THE 26
# define ALWAYS 27
# define SOMETIME 28
# define HALT 29
# define INIT 30
# define FIN 31
# define KEEP 32
# define NEXT 33
# define WNEXT 34
# define LEN 35
# define iLEN 36
# define LT 37
# define LE 38
# define EQ 39
# define GE 40
# define GT 41
# define NEQ 42
# define GETS 43
# define STB 44
# define WHERE 45
# define IS 46
# define ASSN 47
# define UASSN 48
# define SEMI 49
# define iSEMI 50
# define WHILE 51
# define REPEAT 52
# define FOR 53
# define iFOR 54
# define FORTIMES 55
# define iFORTIMES 56
# define FORIN 57
# define iFORIN 58
# define PROJ 59
# define iPROJ 60
# define INPUT 61
# define OUTPUT 62
# define PLUS 63
# define MINUS 64
# define MULT 65
# define DIV 66
# define MOD 67
# define POWER 68
# define UPLUS 69
# define UMINUS 70
# define MAKELIST 71
# define TYPE 72
# define STRUCT 73
# define SIZE 74
# define SUB 75
# define SUBLIST 76
# define FIXLIST 77
# define VARLIST 78
# define REFER 79
# define DEREF 80
# define LOC 81
# define RUN 82
# define EXIT 83
# define LOAD 84
# define DEFINE 85
# define SET 86
# define SHOWTRACE 87
# define SHOWMEM 88
# define ABORT 89
# define BREAK 90
# define RETURN 91
# define CONTINUE 92
# define LEAP 93
# define STEP 94
# define PEEK 95
# define FORMAT 96
# define ASCII 97
# define HELP 98
# define SYSTEM 99
# define iSYSTEM 100
# define PASSLIMIT 101
# define VERBOSITY 102
# define PRINTLEVEL 103
# define DEBUGLEVEL 104
# define STATEPRINT 105
# define REDUNDANCY 106
# define CALLBYNAME 107
# define ASSIGNAHEAD 108
# define BREAKISABORT 109
# define PATH 110
# define HELPDIR 111
# define TIMESTEP 112
# define RANDOM 113
# define RANDSEED 114
# define RRANDOM 115
# define RRANDSEED 116
# define MAXRANDLEN 117
# define IMPLIES 118
# define MORE 119
# define CHOPSTAR 120
# define iIF 121
# define iUNDEFINED 122
# define SHOWSTATE 123
# define INFILE 124
# define OUTFILE 125
# define RANLEN 126
# define INFINITE 127
# define HOPCHOP 128
# define PRECISION 129
# define CEIL 130
# define FLOOR 131
# define SQRT 132
# define ITOF 133
# define EXPO 134
# define LOG 135
# define LOGTEN 136
# define SIN 137
# define COS 138
# define TAN 139
# define ASIN 140
# define ACOS 141
# define ATAN 142
# define ATANTWO 143
# define SINH 144
# define COSH 145
# define TANH 146
# define FABS 147
# define SRANDOM 148
# define SRANDSEED 149
# define SRRANDOM 150
# define SRRANDSEED 151
# define iOR 152
# define DEFAULTS 153
# define MEM 154
# define PREV 155
# define NPREV 156
# define WINPUT 157

# define COMMA 158

# define TRUE 159
# define FALSE 160
# define NAME 161
# define THEN 162
# define ELSE 163
# define IN 164
# define TIMES 165
# define ENV 166
# define BND 167
# define TO 168
# define DO 169
# define LPAREN 170
# define RPAREN 171
# define LBRACE 172
# define RBRACE 173
# define LBRACK 174
# define RBRACK 175
# define BAR 176
# define UNTIL 177
# define HISTORY 178
# define MEMBLOCK 179


#define MAXREDUCETOKEN COMMA
#define MAXTOKEN MEMBLOCK

#define MQS MAXTOKEN+1
#define STL MQS+1
#define N1 STL+1
#define IDN N1+1
#define MDF IDN+1
#define EIF MDF+1
#define FTL EIF+1
#define H1 FTL+1
#define NLC H1+1
