/* This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995,
 * 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
 * 2007, 2008, 2009, 2010, 2011, 2012  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Changes made by  AC: Antonio Cau
 *                 BCM: Ben Moszkowski
 *
 * $Id: system.h,v 2.15 2011/10/03 14:14:30 acau Exp $
 */
#include <config.h>
#include <stdio.h>
#include <ctype.h>
#include <setjmp.h>
#include <signal.h>
#include <limits.h>
#include <math.h>
#ifdef HAVE_SYS_WAIT_H
#include <sys/wait.h>
#endif
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "parser.h"
#include "tempura.h"
#include "globals.h"


#ifdef _AIX
#   define WAIT_STATUS_TYPE pid_t
#else
#ifndef NO_UNION_WAIT
#   define WAIT_STATUS_TYPE union wait
#else
#   define WAIT_STATUS_TYPE int
#endif
#endif

#if defined (__MINGW) || defined(__MINGW32__)
double drand48(void);
double erand48(unsigned short xsubi[3]);
long int lrand48(void);
long int nrand48(unsigned short xsubi[3]);
long int mrand48(void);
long int jrand48(unsigned short xsubi[3]);
void srand48(long int seedval);
unsigned short *seed48(unsigned short seed16v[3]);
void lcong48(unsigned short param[7]);
#endif

#define free_mem(A) if (A != NULL) free (A)

#define resetin(F) if (feof(F)) {(F)->_cnt=0;(F)->_flag^=_IOEOF;}
/*#define resetin(F)*/

/*#define MAXSYSVAR 9*/
#define HASHTABLESIZE 200


/* For the VAX, SUN, etc: */
#define MAXHISTORY 25
#define MAXSYMBOLTABLESIZE 1000
#define MAXHEAPSIZE 10000
#define GLOBALMEMSIZE 5000
#define MAXENVSTACKSIZE 400
#define MAXREDUCESTACKSIZE 1000
#define MAXTOKENSIZE 256
#define MAXFILENAMESIZE 256
#define MAXINTSIZE 20
#define MAXFLSIZE 32
#define FILENAMESEP '/'
#define FX ".t"
#define FXOUT ""
#define FXIN ""
#define HELPSUMMARY "summary"

/* For the PC:
#define MAXSYMBOLTABLESIZE 300
#define MAXHEAPSIZE 3200
#define GLOBALMEMSIZE 200
#define MAXENVSTACKSIZE 100
#define MAXREDUCESTACKSIZE 100
#define MAXTOKENSIZE 257
#define MAXFILENAMESIZE 40
#define MAXINTSIZE 20
#define FILENAMESEP '\\'
#define FX ".t"
#define HELPSUMMARY "summary"
#define CNTRL_C 0x23
#define INTERRUPTSTACK 128
*/
